=== benchmarks/01_trivial/CMakeLists.txt ===
#
#  Copyright (c) 2020-2025, Intel Corporation
#
#  SPDX-License-Identifier: BSD-3-Clause

# List the benchmarks
compile_benchmark_test(01_aossoa)
compile_benchmark_test(02_soaaos)
compile_benchmark_test(03_popcnt)
compile_benchmark_test(04_fastdiv)
compile_benchmark_test(05_packed_load_store)
compile_benchmark_test(06_math)
compile_benchmark_test(07_loop_unroll_varying)
compile_benchmark_test(08_masked_load_store)
compile_benchmark_test(09_shuffle)
compile_benchmark_test(10_cttz_ctlz)
compile_benchmark_test(11_lanemask)
compile_benchmark_test(12_broadcast)
compile_benchmark_test(13_rotate)
compile_benchmark_test(14_shift)
compile_benchmark_test(15_reduce_equal)
