=== benchmarks/02_medium/CMakeLists.txt ===
#
#  Copyright (c) 2020-2025, Intel Corporation
#
#  SPDX-License-Identifier: BSD-3-Clause

# List the benchmarks
compile_benchmark_test(test01)
compile_benchmark_test(test02_array)
compile_benchmark_test(test03_int_div)
