=== debian/changelog ===
ispc (1.28.2-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * Add minimal debian/gbp.conf
  * Disable building new library to avoid the NEW queue

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 24 Oct 2025 19:01:03 -0400
